<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenner
 * Date: 17/01/14
 * Time: 09:05
 */

namespace Folha\Facade\Relatorios;

class Admissao {
    /**
     * Verifica se os fields estão corretamente preenchidos de acordo com o relatório selecionado
     * pck 17/01/2013 
     */
    public static function verificaFields() {
        switch(tk_get_field_value('REPORT_NAME')) {  //Nome do relatório
            case '':    //Nenhum relatório selecionado
                tk_abort('Nenhum relatório selecionado.');
                break;
            case 'contrato_trabalho_regime_experiencia':
                if(tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário selecionar o Tipo de Estrutura para o Empregador para emitir este relatório');
                break;
            case 'declaracao_salario_familia':
            //case 'declaracao_vale_transporte':
                if(tk_get_field_value('NRVINCULO') == null)
                    tk_abort('É necessário selecionar um Vínculo para emitir este relatório');
                break;
            case 'termo_prorrogacao':
                if(tk_get_field_value('NRVINCULO') == null || tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário selecionar um Vínculo e o Tipo de Estrutura para o Empregador para emitir este relatório');
                break;
//            case 'etiqueta':
//                if(tk_get_field_value('DATAINICIO') == null ||
//                        tk_get_field_value('DATAFINAL') == null)
//                     tk_abort ('É necessário selecionar um Período Inicial e Final para emitir este relatório');
//                break;
            case 'registro_empregado':
                if(tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário selecionar o Tipo de Estrutura Empresa desta organização para emitir este relatório');
                break;
            //Relatórios que não possuem parâmetros obrigatórios
            case 'etiqueta':                    //Nova inclusão
            case 'etiqueta2':                   //Nova inclusão
            case 'etiqueta3':                   //Nova inclusão
            case 'declaracao_vale_transporte':  //Nova inclusão
            case 'etiqueta_cartao_ponto':       //Nova inclusão 17-09-2014
            case 'declaracao_recebimento_vale_transporte': //16-10-2014
            case 'declaracao_encargos_familia_imposto_de_renda':
            case 'folha_ponto':
            case 'controle_contrato_experiencia':
            case 'ficha_salario_familia':
            case 'declaracao_vale_alimentacao':
                break;
            default:
                tk_abort('Este relatório não está integrado');
        }
    }

}