<?php
/**
 * PercorrePreparacao.
 *
 * @package Logic
 *
 * @author  alessandrobartels
 */
class PercorrePreparacao{

    private $_nrorg;
    private $_nrOrgPadrao;
    private $_nrOrgTrabalho;
    private $_nrEstruturaTrab;
    private $_nrTipoModalidadeCalculo;
    private $_nrOcorrenciaCalculo;

    private $_parametros;
    private $_formulario;

    private $_prep;
    private $_nr_tipo_calculo;
    private $_retrocesso;
    private $_dtPagamento;
    private $_dtInicio;
    private $_dtFim;
    private $_dsInicio;
    private $_dsFim;
    private $_idRetrocesso;
    private $_dsOrdem;
    //BORBA 06/02/2014 Utilizados para lançamento de gozo e abertura de proximo periodo aquisitivo em caso de Fer Coletivas
    private $_dtRetornoferias;
    private $_dtIniProxPeriodo;
    private $_FlagFerias;
    private $_idFeriascoletivas;

    private $_tipo_movimento;

    private $_tipo_calculo;
    private $_calculo_folha;
    private $_mes_competencia;
    private $_simulacao;
    private $_vinculom;
    private $_tp_calc_mov;

    private $_calc_13sal;
    private $_calc_adiant_13sal;
    private $_calc_ferias;


    /**
     * Construtor.
     *
     * @param integer       $nr_tipo_calculo  Numero do Tipo de Calculo.
     * @param string        $tp_processamento Tipo de Processo.
     * @param integer       $nrFormulario     Numero do Formulario.
     * @param Parametros    $parametro       Instancia de Parametros.
     * @param boolean       $idFeriascoletivas
     */
    public function __construct($nr_tipo_calculo, $tp_processamento, $nrFormulario, Parametros $parametro,$idFeriascoletivas=null){
            $dt_pagamento = false;

        $this->_nr_tipo_calculo = $nr_tipo_calculo;
        $this->_parametros = $parametro;
        $this->_nrOrgTrabalho = $this->_parametros->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $this->_parametros->getNrOrgPadrao();
        $this->_idFeriascoletivas = $idFeriascoletivas;
        $this->_nrEstruturaTrab = \FPA::getEstruturaTrabalho();//leandroafonso 06/08
        $this->_mes_competencia = $this->_parametros->getMesCompetencia();
        $this->_nrTipoModalidadeCalculo = $this->_parametros->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalculo = $this->_parametros->getNrOcorrenciaCalculo();

        $this->_buscaDadosFormulario($nrFormulario);

        /*
        $this->_dtPagamento = $dt_pagamento;
        $this->_idRetrocesso = $id_retrocesso;
        $this->_dtInicio = $dt_inicio;
        $this->_dtFim = $dt_fim;
        $this->_dsOrdem = $dsOrdem;
        */

        Inicializa::Container($this->_nrOrgTrabalho, $this->_nrOrgPadrao, $this->_mes_competencia, $this->_dtPagamento);

        $this->_vinculom = TkDI::getContainer()->vinculom;
        $this->_tipo_calculo = TkDI::getContainer()->tipo_calculo;
        $this->_calculo_folha = TkDI::getContainer()->calculo_folha;
        $this->_tp_calc_mov = TkDI::getContainer()->tp_calc_mov;

        $this->_retrocesso = false;
        $tp_processamento = strtoupper($tp_processamento);
        switch ($tp_processamento){
        case Parametros::PROC_SIMULACAO :
            $this->_simulacao = true; break;
        case Parametros::PROC_CALCULO :
            $this->_simulacao = false; break;
        case Parametros::PROC_RETROCESSO :
            $this->_retrocesso = true; break;
        default:
            tk_message('Tipo de processo '.$tp_processamento.' invalido', 'warning');
        }

    }


    /**
     * Enter description here ...
     *
     * @throws Exception $e.
     *
     * @return multitype:
     *
     * alessandrobartels - 23/08/2011 - $mesCompetencia parametrizado passa a ser feito pelo construtor.
     */
    public function percorre() {

        /* $ambiente_salario_operador = $parametro->ambienteSalarioOperador(); */
        $objTipoCalculo = new FpatipocalculoEntity();
        $objTpCalc = $objTipoCalculo->retornaTipoCalculo($this->_nr_tipo_calculo);

        $demonstrativo = new Demonstrativo(
            $objTpCalc->getNmtipocalculo(), $this->_mes_competencia->toString(TkDateTime::FORMAT_DATE)
        );
        try {
            $this->_tp_calc_mov->retornaTipoCalculoMovimento($this->_nr_tipo_calculo);
        } catch (Exception $e){
            throw $e;
        }

        $this->_tp_calc_mov->atribuiNrCalculoFolha(
            $this->_nrOrgTrabalho, $this->_calculo_folha, $this->_mes_competencia, $this->_nrTipoModalidadeCalculo,
            $this->_nrOcorrenciaCalculo
        );

        /*$this->_prep = new Preparacao(
            $this->_parametros, $this->_nrOrgPadrao, $this->_nrOrgTrabalho, $this->_nr_tipo_calculo,
            $this->_mes_competencia, $id_retrocesso, $this->_dtInicio, $this->_dtFim, $this->_simulacao,
            $this->_dtPagamento
        );*/

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO) {
            $vinculos = $this->_vinculom->retornaVinculosDemitidosMesCompetencia(
                $this->_nrOrgTrabalho, $this->_mes_competencia, $this->_dsInicio, $this->_dsFim, $this->_dtInicio,
                $this->_dtFim, $this->_dsOrdem, $this->_nrEstruturaTrab
            );
        } else {
            $vinculos = $this->_vinculom->retornaVinculosAtivosMesCompetencia(
                $this->_nrOrgTrabalho, $this->_mes_competencia, $this->_dsInicio, $this->_dsFim, $this->_dsOrdem, false,
                $this->_nrEstruturaTrab
            );
        }

        $qtd_vinculo = count($vinculos);
        if ($qtd_vinculo > 0) {
            $resultado = array();
            $contador = 0;
            $this->_prep = new Preparacao(
                $this->_parametros, $this->_formulario, $this->_nr_tipo_calculo, $this->_simulacao, $this->_idRetrocesso
            );

            foreach ($vinculos as $vinculo) {
                $contador++;

                //se estiver simulando limita a quantidade de vinculos a 10 registros
                //leandroafonso 06/08
                if($contador>10 && $this->_simulacao==true){
                    tk_warning("Simulado e demonstrado apenas os 10 primeiros vínculos da lista. Para calcular mais vínculos será necessário gravar.");
                    break;
                }


                if ($this->_retrocesso === false) {
                    $result_parcial = array();
                    try {
                        $result_parcial = $this->_prep->preparar($vinculo, $this->_tp_calc_mov, $demonstrativo, $contador);
                    } catch (\Folha\Exceptions\FeriasCalculo $e) {
                        if ($e->getCode() != 2) {
                            tk_warning($e->getMessage());
                        }
                        continue;
                    }

                    /*
                    if ($this->_simulacao === true) {
                        if (!empty($result_parcial)) {
                            $resultado[$vinculo->getNrvinculom()]['CABECALHO'] = 'Vinculo: '.$vinculo->getNrvinculom();
                            for ($i=0; $i<count($result_parcial); $i++) {
                                $resultado[$vinculo->getNrvinculom()]['ITEMCALCULO'][$i] = $result_parcial[$i];
                            }
                        }
                    }
                    */
                } else {
                    $this->_prep->retroceder($vinculo, $this->_tp_calc_mov);
                }
            }

            return $demonstrativo;
        } else {
            return null;
        }
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrFormulario Numero do formulario.
     *
     * @throws Exception Propaga excecao.
     *
     * @return void
     */
    private function _buscaDadosFormulario($nrFormulario) {
        //BORBA 06/02/2014 - ferias coletivas forçado pra true - Apagar posteriormente até que se resolva como passar este valor.
        //$this->_idFeriascoletivas=true;
        switch ($this->_nr_tipo_calculo) {
        case FpatipocalculoEntity::CALC_FERIAS :
            //BORBA 06/02/2014 - ferias coletivas - O tipo de calculo é o mesmo porém o formulário é de outra tabela
            if($this->_idFeriascoletivas==null){
                $this->_buscaDadosFormularioFerias($nrFormulario);
            }else{
                $this->_buscaDadosFormularioFeriasColetivas($nrFormulario);
            }
            break;

        case FpatipocalculoEntity::CALC_RESCISAO :
            $this->_buscaDadosFormularioRescisao($nrFormulario);
            break;
        //BORBA 25/02/2014
        case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR :
            $this->_buscaDadosFormularioRescocomplementar($nrFormulario);
            break;

        default:
            $this->_buscaDadosFormularioCalculo($nrFormulario);
            break;
        }
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrFormulario Numero do formulario.
     *
     * @throws Exception Propaga excecao.
     *
     * @return void
     */
    private function _buscaDadosFormularioCalculo($nrFormulario){
        $formulario = new FpaFormcalculoEntity();
        $this->_formulario = $formulario->retornaDadosFormularioCalculo($this->_nrOrgTrabalho, $nrFormulario);
        if (is_object($this->_formulario) === true) {
            $this->_dsInicio = $this->_formulario->getDsinicio();
            $this->_dsFim = $this->_formulario->getDsfim();
            $this->_dsOrdem = $this->_formulario->getDsordem();
            $this->_dtPagamento = $this->_formulario->getDtpagamento();
            $this->_idRetrocesso = $this->_formulario->getIdretrocesso();
        }
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrFormulario Numero do formulario.
     *
     * @throws Exception Propaga excecao.
     *
     * @return void
     */
    private function _buscaDadosFormularioFerias($nrFormulario){
        $formulario = new FpaFormferiasEntity();
        $this->_formulario = $formulario->retornaDadosFormularioFerias($this->_nrOrgTrabalho, $nrFormulario);
        if (is_object($this->_formulario) === true) {
            $this->_dsInicio = $this->_formulario->getDsinicio();
            $this->_dsFim = $this->_formulario->getDsfim();
            $this->_dsOrdem = $this->_formulario->getDsordem();
            $this->_dtPagamento = $this->_formulario->getDtpagamento();
            $this->_dtInicio = $this->_formulario->getDtinigozoini();
            $this->_dtFim = $this->_formulario->getDtinigozofim();
            $this->_idRetrocesso = $this->_formulario->getIdretrocesso();
        }
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrFormulario Numero do formulario.
     *
     * @throws Exception Propaga excecao.
     *
     * @return void
     */
    private function _buscaDadosFormularioRescisao($nrFormulario){
        $formulario = new FpaformrescisaoEntity();
        $this->_formulario = $formulario->retornaDadosFormularioRescisao($this->_nrOrgTrabalho, $nrFormulario);
        if (is_object($this->_formulario) === true) {
            $this->_dsInicio = $this->_formulario->getDsinicio();
            $this->_dsFim = $this->_formulario->getDsfim();
            $this->_dsOrdem = $this->_formulario->getDsordem();
            $this->_dtPagamento = $this->_formulario->getDtpagamento();
            $this->_dtInicio = $this->_formulario->getDtrescisaoini();
            $this->_dtFim = $this->_formulario->getDtrescisaofim();
            $this->_idRetrocesso = $this->_formulario->getIdretrocesso();
        }
    }

    /**
     * Bruno Borba / 06/02/2014
     *
     * @param integer $nrFormulario Numero do formulario.
     *
     * @throws Exception Propaga excecao.
     *
     * @return void
     */
    private function _buscaDadosFormularioFeriasColetivas($nrFormulario){

        $this->_formulario = \Folha\Entities\FpaFormferiascolet::findOneByNrorgAndNrformferias($this->_nrOrgTrabalho, $nrFormulario);
        if (is_object($this->_formulario) === true) {
            $this->_dsInicio = $this->_formulario->getDsinicio();
            $this->_dsFim = $this->_formulario->getDsfim();
            $this->_dsOrdem = $this->_formulario->getDsordem();
            $this->_dtPagamento = $this->_formulario->getDtpagamento();
            $this->_dtInicio = $this->_formulario->getDtinigozoini();
            $this->_dtFim = $this->_formulario->getDtinigozofim();
            $this->_idRetrocesso = $this->_formulario->getIdretrocesso();
            $this->_dtRetornoferias = $this->_formulario->getDtretornoferias();
            $this->_dtIniProxPeriodo = $this->_formulario->getDtiniperaquistivo();
            $this->_FlagFerias = $this->_formulario->getDsferiascolet();

        }
    }

    /**
     * BORBA 25/02/2014 ...
     *
     * @param integer $nrFormulario Numero do formulario.
     *
     * @throws Exception Propaga excecao.
     *
     * @return void
     */
    private function _buscaDadosFormularioRescocomplementar($nrFormulario){

        //$formulario = new FpaformrescisaoEntity();
        //$this->_formulario = $formulario->retornaDadosFormularioRescisao($this->_nrOrgTrabalho, $nrFormulario);
        $this->_formulario = \Folha\Entities\FpaFormresccomplementar::findOneByNrorgAndNrformrescisao($this->_nrOrgTrabalho, $nrFormulario);
        if (is_object($this->_formulario) === true) {
            $this->_dsInicio = $this->_formulario->getDsinicio();
            $this->_dsFim = $this->_formulario->getDsfim();
            $this->_dsOrdem = $this->_formulario->getDsordem();
            $this->_dtPagamento = $this->_formulario->getDtpagamento();
            $this->_dtInicio = $this->_formulario->getDtrescisaoini();
            $this->_dtFim = $this->_formulario->getDtrescisaofim();
            $this->_idRetrocesso = $this->_formulario->getIdretrocesso();
        }
    }

}